define([
  '../utils'
], function (Utils) {
  function MultipleSelection ($element, options) {
    this.$element = $element;
    this.options = options;

    MultipleSelection.__super__.constructor.call(this);
  }

  Utils.Extend(MultipleSelection, Utils.Observable);

  MultipleSelection.prototype.render = function () {
    var $selection = $(
      '<span class="multiple-select">' +
        '<ul class="rendered-selection"></ul>' +
      '</span>'
    );

    this.$selection = $selection;

    return $selection;
  }

  MultipleSelection.prototype.bind = function (container, $container) {
    var self = this;

    this.$selection.on('click', function (evt) {
      self.trigger("toggle", {
        originalEvent: evt
      });
    });

    container.on("selection:update", function (params) {
      self.update(params.data);
    });
  }

  MultipleSelection.prototype.clear = function () {
    this.$selection.find(".rendered-selection").empty();
  }

  MultipleSelection.prototype.display = function (data) {
    return data.text;
  }

  MultipleSelection.prototype.update = function (data) {
    this.clear();

    if (data.length == 0) {
      return;
    }

    var $selections = [];

    for (var d = 0; d < data.length; d++) {
      var selection = data[d];

      var formatted = this.display(selection);

      var $selection = $('<ul class="choice"></ul>');

      $selection.text(formatted);
      $selection.data("data", data);

      $selections.push($selection);
    }

    this.$selection.find(".rendered-selection").append($selections);
  }

  return MultipleSelection;
});
